Attribute VB_Name = "SET_Default"
Sub SET_hide_reference_geometry()
If ThisApplication.ActiveDocumentType = kPartDocumentObject Then
On Error Resume Next

        Dim oPart As PartDocument
        Set oPart = ThisApplication.ActiveDocument
    
        
        Dim oPlane As WorkPlane
        Dim oAxis As WorkAxis
        Dim oSketch As Sketch
        Dim oPoint As WorkPoint
        Dim oSurface As WorkSurface
        
        
        
        For Each oAxis In oPart.ComponentDefinition.WorkAxes
            oAxis.Visible = False
        Next
        
        For Each oPlane In oPart.ComponentDefinition.WorkPlanes
            oPlane.Visible = False
        Next
        
        For Each oSketch In oPart.ComponentDefinition.Sketches
            oSketch.Visible = False
        Next

        For Each oPoint In oPart.ComponentDefinition.WorkPoints
            oPoint.Visible = False
        Next

        For Each oSurface In oPart.ComponentDefinition.WorkSurfaces
            oSurface.Visible = False
        Next

End If
End Sub

Sub SET_show_reference_geometry()
If ThisApplication.ActiveDocumentType = kPartDocumentObject Then
On Error Resume Next

        Dim oPart As PartDocument
        Set oPart = ThisApplication.ActiveDocument
    
        
        Dim oPlane As WorkPlane
        Dim oAxis As WorkAxis
        Dim oSketch As Sketch
        Dim oPoint As WorkPoint
        Dim oSurface As WorkSurface
        
        
        
        For Each oAxis In oPart.ComponentDefinition.WorkAxes
            oAxis.Visible = True
        Next
        
        For Each oPlane In oPart.ComponentDefinition.WorkPlanes
            oPlane.Visible = True
        Next
        
        For Each oSketch In oPart.ComponentDefinition.Sketches
            oSketch.Visible = True
        Next

        For Each oPoint In oPart.ComponentDefinition.WorkPoints
            oPoint.Visible = True
        Next

        For Each oSurface In oPart.ComponentDefinition.WorkSurfaces
            oSurface.Visible = True
        Next

End If
End Sub

Sub SET_piping_table()
'BLOCK
On Error GoTo 1

ThisApplication.StatusBarText = "Biegetabelle wird berechnet. Bitte warten..."

Dim oPartDoc As AssemblyDocument
Dim oPipeDoc As PartDocument
Dim oDrawDoc As DrawingDocument
Dim oSheet As Sheet
Dim oTG As TransientGeometry
Set oTG = ThisApplication.TransientGeometry
Set oDrawDoc = ThisApplication.ActiveDocument
Set oSheet = oDrawDoc.ActiveSheet
Set oPartDoc = oDrawDoc.AllReferencedDocuments(1)
Set oPipeDoc = oPartDoc.AllReferencedDocuments(1)
Dim SKA As Sketch3D
Set SKA = oPipeDoc.ComponentDefinition.Sketches3D(1)
Dim oFrontView As DrawingView
Set oFrontView = oSheet.DrawingViews.AddBaseView(oPartDoc, oTG.CreatePoint2d((oSheet.Width - 20) / 2, (oSheet.height - 12) / 2), 1, kIsoTopLeftViewOrientation, kHiddenLineDrawingViewStyle)
oFrontView.SetIncludeStatus SKA, True
Dim i As Long 'Laufvariable

Dim StatusTEXT As String

Dim Numberofpoints As Double
Numberofpoints = SKA.SketchPoints3D.Count



If Numberofpoints < 4 Then
MsgBox "The Pipe must have at least one bend! Makro will be cancelled", vbCritical, "Piping Makro"
Exit Sub
End If

Dim oTable As CustomTable

Dim Collums(8) As String
Collums(0) = "Punkt" & vbCrLf & "point"
Collums(1) = "X"
Collums(2) = "Y"
Collums(3) = "Z"
Collums(4) = "Biegeradius" & vbCrLf & "bending radius"
Collums(5) = "Biegewinkel" & vbCrLf & "bending angle"
Collums(6) = "Verdrehwinkel" & vbCrLf & "twist angle"
Collums(7) = "Bogenlnge" & vbCrLf & "arc length"
Collums(8) = "Gerade Lnge" & vbCrLf & "straight length"
    Dim oColumnWidths(8) As Double
    oColumnWidths(0) = 1.1
    oColumnWidths(1) = 2
    oColumnWidths(2) = 2
    oColumnWidths(3) = 2
    oColumnWidths(4) = 2.5
    oColumnWidths(5) = 2.5
    oColumnWidths(6) = 2.5
    oColumnWidths(7) = 2.5
    oColumnWidths(8) = 2.5
'Prfen ob eine Tabelle bereits am blatt ist...
Dim tableExists As Integer
tableExists = 100

For i = 1 To oSheet.CustomTables.Count
If oSheet.CustomTables.Item(i).Title = "Biegetabelle / bending table" Then
tableExists = i
Exit For
End If
Next i
If tableExists < 100 Then
StatusTEXT = "Biegetabelle wird aktualisiert. Bitte warten."
Set oTable = oSheet.CustomTables(tableExists)
    For i = 1 To 100
    On Error GoTo 3
    oTable.Rows.Item(i).Delete
    Next i
3:
On Error GoTo 1
    For i = 0 To 8
    oTable.Columns(i + 1).Title = Collums(i)
    Next i

Else
StatusTEXT = "Neue Biegetabelle wird erstellt. Bitte warten."
Set oTable = oSheet.CustomTables.Add("Biegetabelle / bending table", oTG.CreatePoint2d(2.5, oSheet.height - 3), 9, 1, Collums, , oColumnWidths)
End If

'Tabelle formatieren
'oTable.HeadingPlacement = kNoHeading
oTable.ShowTitle = False


For i = 1 To 9
oTable.Columns(i).ValueHorizontalJustification = kAlignTextCenter
oTable.Columns(i).TitleHorizontalJustification = kAlignTextCenter
Next i

Dim myTable(99, 9)


For i = 1 To Numberofpoints
myTable(i, 9) = "P" & CStr(i)
myTable(i, 1) = SKA.SketchPoints3D(i).Geometry.x ' - SKA.SketchPoints3D(1).Geometry.x
myTable(i, 2) = SKA.SketchPoints3D(i).Geometry.Y ' - SKA.SketchPoints3D(1).Geometry.Y
myTable(i, 3) = SKA.SketchPoints3D(i).Geometry.Z ' - SKA.SketchPoints3D(1).Geometry.Z
Next i


'ENDBLOCK

Dim KoordAlt As mSet.mKSystem
Dim KoordNeu As mSet.mKSystem

'Standardkoordinatensystem
KoordAlt.xAchse.x = 1
KoordAlt.xAchse.Y = 0
KoordAlt.xAchse.Z = 0
KoordAlt.yAchse.x = 0
KoordAlt.yAchse.Y = 1
KoordAlt.yAchse.Z = 0
KoordAlt.zAchse.x = 0
KoordAlt.zAchse.Y = 0
KoordAlt.zAchse.Z = 1


' Neues Koordinatensystem aus den ersten 3 Punkten der Linie
KoordNeu.xAchse.x = myTable(2, 1) - myTable(1, 1) 'P2x - P1x
KoordNeu.xAchse.Y = myTable(2, 2) - myTable(1, 2) 'P2y - P1y
KoordNeu.xAchse.Z = myTable(2, 3) - myTable(1, 3) 'P2z - P1z
    Dim Hilfsvektor As mSet.mVector
    Hilfsvektor.x = myTable(3, 1) - myTable(1, 1)
    Hilfsvektor.Y = myTable(3, 2) - myTable(1, 2)
    Hilfsvektor.Z = myTable(3, 3) - myTable(1, 3)
KoordNeu.zAchse = mSet.eVektorProdukt(KoordNeu.xAchse, Hilfsvektor)
KoordNeu.yAchse = mSet.eVektorProdukt(KoordNeu.zAchse, KoordNeu.xAchse)

Dim rotMat As mSet.mRotationsMatrix

rotMat = createRotMatrix(KoordNeu, KoordAlt)

Dim myTableNeu(99, 9)

'Punkte Transformieren
For i = 1 To Numberofpoints
myTableNeu(i, 1) = rotMat.RMax * myTable(i, 1) + rotMat.RMay * myTable(i, 2) + rotMat.RMaz * myTable(i, 3)
myTableNeu(i, 2) = rotMat.RMbx * myTable(i, 1) + rotMat.RMby * myTable(i, 2) + rotMat.RMbz * myTable(i, 3)
myTableNeu(i, 3) = rotMat.RMcx * myTable(i, 1) + rotMat.RMcy * myTable(i, 2) + rotMat.RMcz * myTable(i, 3)
Next i
For i = 1 To Numberofpoints
myTable(i, 1) = myTableNeu(i, 1) - myTableNeu(1, 1)
myTable(i, 2) = myTableNeu(i, 2) - myTableNeu(1, 2)
myTable(i, 3) = myTableNeu(i, 3) - myTableNeu(1, 3)
Next i

' Tabelle sortieren und Werte berechnen
Dim j As Double 'Laufvariable2

' alle Werte auf die neue Tabelle kopieren
For i = 1 To Numberofpoints
For j = 1 To 9
 myTableNeu(i, j) = myTable(i, j)
Next j
Next i

'Werte von der neuen Tabelle auf der alten einordnen
If Numberofpoints = 5 Then
Erase myTable
' Hauptpunkte einordnen
    '1. Punkt sollte immer 0,0,0 sein
    For j = 1 To 9
    myTable(1, j) = myTableNeu(1, j)
    Next j
    '2. Punkt
    For j = 1 To 9
    myTable(2, j) = myTableNeu(4, j)
    Next j
    '3.Punkt
    For j = 1 To 9
    myTable(3, j) = myTableNeu(2, j)
    Next j
    '4. Punkt
    For j = 1 To 9
    myTable(4, j) = myTableNeu(5, j)
    Next j
    '5.Punkt
    For j = 1 To 9
    myTable(5, j) = myTableNeu(3, j)
    Next j
End If

If Numberofpoints > 5 Then
Erase myTable
For i = 3 To Numberofpoints - 3 Step 3
    For j = 1 To 9
    myTable(i + 2, j) = myTableNeu(i + 4, j)
    myTable(i + 3, j) = myTableNeu(i, j)
    myTable(i + 4, j) = myTableNeu(i + 5, j)
    Next j
Next i
    '2. Punkt
    For j = 1 To 9
    myTable(2, j) = myTableNeu(4, j)
    Next j
    '3.Punkt
    For j = 1 To 9
    myTable(3, j) = myTableNeu(2, j)
    Next j
    '4. Punkt
    For j = 1 To 9
    myTable(4, j) = myTableNeu(5, j)
    Next j
    'letzter Punkt
    For j = 1 To 9
    myTable(Numberofpoints, j) = myTableNeu(Numberofpoints - 2, j)
    Next j
End If


'Neu Nummerieren
For i = 1 To Numberofpoints
myTable(i, 9) = "P" & CStr(i)
Next i

' Biegewinkel, Biegeradius und Bogenlnge
Dim Vekt(6) As mSet.mVector
For i = 3 To Numberofpoints Step 3
Vekt(1) = eVektor(i, myTable)
Vekt(2) = eVektor(i - 2, myTable)
Vekt(3) = eVektor(i + 2, myTable)
Vekt(4) = mSet.zweiPunktVektor(Vekt(1), Vekt(2))
Vekt(5) = mSet.zweiPunktVektor(Vekt(3), Vekt(1))
myTable(i, 5) = ArcCos(mSet.eRMatrixElement(Vekt(4), Vekt(5))) * 180 / mSet.Pi()
myTable(i, 7) = SKA.SketchArcs3D(i / 3).Length * 10
myTable(i, 4) = myTable(i, 7) * 360 / (2 * mSet.Pi() * myTable(i, 5))
Next i

'Gerade lnge
For i = 1 To Numberofpoints Step 3
Vekt(1) = eVektor(i, myTable)
Vekt(2) = eVektor(i + 1, myTable)
Vekt(3) = mSet.zweiPunktVektor(Vekt(1), Vekt(2))

myTable(i + 1, 8) = Sqr(Vekt(3).x ^ 2 + Vekt(3).Y ^ 2 + Vekt(3).Z ^ 2)
Next i

'Verdrehwinkel (tiltangle)
If Numberofpoints > 6 Then

For i = 6 To Numberofpoints Step 3
Vekt(1) = eVektor(i - 3, myTable)
Vekt(2) = eVektor(i - 4, myTable)
Vekt(3) = eVektor(i + 1, myTable)
Vekt(4) = eVektor(i, myTable)

Vekt(5) = mSet.zweiPunktVektor(Vekt(1), Vekt(2))
Vekt(6) = mSet.zweiPunktVektor(Vekt(3), Vekt(4))
myTable(i, 6) = ArcCos(mSet.eRMatrixElement(Vekt(5), Vekt(6))) * 180 / mSet.Pi()
Next i

End If

'gesamtlnge rechnen
Dim oGeneralNote As GeneralNote
Dim Text As String
Dim myValue As Double
myValue = 0



'werte formatieren
For i = 1 To Numberofpoints
myTable(i, 9) = CStr(myTable(i, 9))
myTable(i, 1) = CStr(Round((myTable(i, 1)) * 20, 0) / 2)
myTable(i, 2) = CStr(Round((myTable(i, 2)) * 20, 0) / 2)
myTable(i, 3) = CStr(Round((myTable(i, 3)) * 20, 0) / 2)

If myTable(i, 4) = 0 Then
myTable(i, 4) = ""
Else
myTable(i, 4) = CStr(Round(myTable(i, 4), 0))
End If

If myTable(i, 5) = 0 Then
myTable(i, 5) = ""
Else
myTable(i, 5) = CStr(Round((myTable(i, 5)) * 2, 0) / 2) & ""
End If

If myTable(i, 5) = "" Then
myTable(i, 6) = ""
Else
myTable(i, 6) = CStr(Round((myTable(i, 6)) * 2, 0) / 2) & ""
End If

If myTable(i, 7) = 0 Then
myTable(i, 7) = ""
Else
myValue = myValue + Round(myTable(i, 7), 1)

myTable(i, 7) = CStr(Round(myTable(i, 7), 1))
End If

If myTable(i, 7) = "" Then
myValue = myValue + (Round(myTable(i, 8) * 20, 0) / 2)
myTable(i, 8) = CStr(Round(myTable(i, 8) * 20, 0) / 2)
Else
myTable(i, 8) = ""
End If



Next i
Text = "GESAMTLNGE / WHOLE LENGTH = " & CStr(myValue) & "mm"

'Werte in Tabelle Schreiben
ThisApplication.StatusBarText = StatusTEXT
For i = 1 To Numberofpoints
If oTable.Rows.Count < i Then
oTable.Rows.Add
End If
oTable.Rows.Item(i).Item(1).Value = myTable(i, 9)
oTable.Rows.Item(i).Item(2).Value = myTable(i, 1)
oTable.Rows.Item(i).Item(3).Value = myTable(i, 2)
oTable.Rows.Item(i).Item(4).Value = myTable(i, 3)
oTable.Rows.Item(i).Item(5).Value = myTable(i, 4)
oTable.Rows.Item(i).Item(6).Value = myTable(i, 5)
oTable.Rows.Item(i).Item(7).Value = myTable(i, 6)
oTable.Rows.Item(i).Item(8).Value = myTable(i, 7)
oTable.Rows.Item(i).Item(9).Value = myTable(i, 8)
oTable.Rows(i).height = 0.35
ThisApplication.StatusBarText = StatusTEXT & " (" & CStr(Round(100 / Numberofpoints * i, 0)) & "%)"
Next i

' Hauptpunkte hervorheben
'For i = 3 To Numberofpoints Step 3
'oTable.Rows(i).height = 0.7
'Next i





For i = 1 To oSheet.DrawingNotes.GeneralNotes.Count
If Mid(oSheet.DrawingNotes.GeneralNotes.Item(i).Text, 1, 8) = "GESAMTL" Then
Set oGeneralNote = oSheet.DrawingNotes.GeneralNotes.Item(i)
oGeneralNote.Text = Text
End If
Next i

'View wieder lschen
If oSheet.DrawingViews.Count > 1 Then
oFrontView.Delete
Else
ThisApplication.StatusBarText = "Temporransicht wird erhalten"
End If

GoTo 2
1:
On Error Resume Next

MsgBox "Makro has been cancelled! Maybe the standard model for this drawing is no Pipe? There has to be a view of a pipe on the sheet!", vbCritical, "Piping Makro"
2:
End Sub
