Attribute VB_Name = "mSet"
Public Type mVector
x As Double
Y As Double
Z As Double
End Type

Public Type mKSystem
xAchse As mVector
yAchse As mVector
zAchse As mVector
End Type

Public Type mRotationsMatrix
RMax As Double
RMay As Double
RMaz As Double
RMbx As Double
RMby As Double
RMbz As Double
RMcx As Double
RMcy As Double
RMcz As Double
End Type

Public Function eVektorProdukt(Vektor1 As mVector, Vektor2 As mVector) As mVector
eVektorProdukt.x = Vektor1.Y * Vektor2.Z - Vektor1.Z * Vektor2.Y
eVektorProdukt.Y = Vektor1.Z * Vektor2.x - Vektor1.x * Vektor2.Z
eVektorProdukt.Z = Vektor1.x * Vektor2.Y - Vektor1.Y * Vektor2.x
End Function

Public Function eSkalarProdukt(Vektor1 As mVector, Vektor2 As mVector) As Double
eSkalarProdukt = Vektor1.x * Vektor2.x + Vektor1.Y * Vektor2.Y + Vektor1.Z * Vektor2.Z
End Function

Public Function eRMatrixElement(Vektor1 As mVector, Vektor2 As mVector) As Double
eRMatrixElement = (Vektor1.x * Vektor2.x + Vektor1.Y * Vektor2.Y + Vektor1.Z * Vektor2.Z) / ((Sqr(Vektor1.x ^ 2 + Vektor1.Y ^ 2 + Vektor1.Z ^ 2) * Sqr(Vektor2.x ^ 2 + Vektor2.Y ^ 2 + Vektor2.Z ^ 2)))
End Function

Public Function zweiPunktVektor(Point1 As mVector, Point2 As mVector) As mVector
' Punkt 1 ist anfang
' Punkt 2 ist Vektorende
zweiPunktVektor.x = Point2.x - Point1.x
zweiPunktVektor.Y = Point2.Y - Point1.Y
zweiPunktVektor.Z = Point2.Z - Point1.Z
End Function

Public Function createRotMatrix(CsysNEU As mSet.mKSystem, CsysALT As mSet.mKSystem) As mSet.mRotationsMatrix
createRotMatrix.RMax = eRMatrixElement(CsysNEU.xAchse, CsysALT.xAchse)
createRotMatrix.RMay = eRMatrixElement(CsysNEU.xAchse, CsysALT.yAchse)
createRotMatrix.RMaz = eRMatrixElement(CsysNEU.xAchse, CsysALT.zAchse)

createRotMatrix.RMbx = eRMatrixElement(CsysNEU.yAchse, CsysALT.xAchse)
createRotMatrix.RMby = eRMatrixElement(CsysNEU.yAchse, CsysALT.yAchse)
createRotMatrix.RMbz = eRMatrixElement(CsysNEU.yAchse, CsysALT.zAchse)

createRotMatrix.RMcx = eRMatrixElement(CsysNEU.zAchse, CsysALT.xAchse)
createRotMatrix.RMcy = eRMatrixElement(CsysNEU.zAchse, CsysALT.yAchse)
createRotMatrix.RMcz = eRMatrixElement(CsysNEU.zAchse, CsysALT.zAchse)
End Function

Public Function eVektor(ByVal PtNr As Double, Matrix) As mSet.mVector
eVektor.x = Matrix(PtNr, 1)
eVektor.Y = Matrix(PtNr, 2)
eVektor.Z = Matrix(PtNr, 3)
End Function

Public Function Pi() As Double
Pi = 4 * Atn(1)
End Function

Public Function ArcCos(x As Double) As Double
If x = 1 Then
  ArcCos = 0
ElseIf x = -1 Then
  ArcCos = Pi()
ElseIf x < 1 And x > -1 Then
  ArcCos = Atn(-x / Sqr((-x * x) + 1)) + Pi() / 2
End If
End Function

Public Function ArcSin(x As Double) As Double
If x = 1 Then
  ArcSin = Pi() / 2
ElseIf x = -1 Then
  ArcSin = -Pi() / 2
ElseIf x < 1 And x > -1 Then
  ArcSin = Atn(x / Sqr((-x * x) + 1))
End If
End Function
